
//+------------------------------------------------------------------+
//|                                             CTrade_Sample_EA.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include<Trade\Trade.mqh>
#property description "       "
#property description "  CTrade.      ."


MqlDateTime my_data;
bool flag = false;


//---     
CTrade  trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
    //---  MagicNumber    
    int MagicNumber=123456;
    trade.SetExpertMagicNumber(MagicNumber);
    //---        /
    int deviation=10;
    trade.SetDeviationInPoints(deviation);
    //---   
    trade.SetTypeFilling(ORDER_FILLING_RETURN);
    //---  :      ,     
    trade.LogLevel(1);
    //---     : true - OrderSendAsync(), false - OrderSend()
    trade.SetAsyncMode(true);
    //---
    return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
    //---

}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{

    nachalo_raboty();

    if(flag)
    {
        TimeCurrent(my_data);
        {
            if (
                my_data.year == 2013 &&
                my_data.mon  ==    3 &&
                my_data.day  ==   15 &&
                my_data.hour ==   21 &&
                my_data.min  >=   00 &&
                my_data.sec  >=   00 
                )
            {
                BuySample3();
                //BuyLimit_Sample2();  //    -    72   
                SellStop_Sample2();
                flag=false;          
            }
        }

        //    -    59-75    79-85

        //string symbol="EURUSD";
        //double bid=SymbolInfoDouble(symbol,SYMBOL_BID);
        //if(bid <= 1.30000) 
        //{
        //    BuySample3(); //       "" ,       - 
        //    flag=false;
        //}
    }
}



//+------------------------------------------------------------------+
//---    
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
void BuySample3()
{
    //--- 3.         SL  TP
    double volume=0.1;         //    
    string symbol="EURUSD";    //  ,    
    int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
    double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
    double bid=SymbolInfoDouble(symbol,SYMBOL_BID);             //     LONG
    double SL=bid-150*point;                                   //   SL
    SL=NormalizeDouble(SL,digits);                              //  Stop Loss
    //double TP=bid+1000*point;     
    double TP=0;                              //   TP
    TP=NormalizeDouble(TP,digits);                              //  Take Profit
    //---      LONG 
    double open_price=SymbolInfoDouble(symbol,SYMBOL_ASK);
    string comment=StringFormat("Buy %s %G lots at %s, SL=%s TP=%s",
        symbol,volume,
        DoubleToString(open_price,digits),
        DoubleToString(SL,digits),
        DoubleToString(TP,digits));
    if(!trade.Buy(volume,symbol,open_price,SL,TP,comment))
    {
        //---   
        Print(" Buy()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
    }
    else
    {
        Print(" Buy()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
    }
    //---
}
//---       
//+------------------------------------------------------------------+
//|                  |
//+------------------------------------------------------------------+
void BuyLimit_Sample2()
{
    //--- 2.     BuyLimit   
    double volume=0.1;
    string symbol="EURUSD";    //  ,    
    int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
    double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
    double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);             //   
    double bid=SymbolInfoDouble(symbol,SYMBOL_BID);             //   
    double price=ask-300*point; //500*point;                                    //   
    price=NormalizeDouble(price,digits);                        //   
    int SL_pips=111;                                            // Stop Loss  
    int TP_pips=500;                                            // Take Profit  
    double SL=price-SL_pips*point;                              //   SL
    SL=NormalizeDouble(SL,digits);                              //  Stop Loss
    double TP=price+TP_pips*point;                              //   TP
    TP=NormalizeDouble(TP,digits);                              //  Take Profit
    datetime expiration=TimeTradeServer()+PeriodSeconds(PERIOD_D1);
    string comment=StringFormat("Buy Limit %s %G lots at %s, SL=%s TP=%s",
        symbol,volume,
        DoubleToString(price,digits),
        DoubleToString(SL,digits),
        DoubleToString(TP,digits));
    //---  ,      Buy Limit
    if(!trade.BuyLimit(volume,price,symbol,SL,TP,ORDER_TIME_GTC,expiration,comment))
    {
        //---   
        Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
    }
    else
    {
        Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
    }
    //---   
}
//---         
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
void SellStop_Sample2()
{
    //--- 2.     Buy Stop   
    double volume=0.1;
    string symbol="EURUSD";    //  ,    
    int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
    double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
    double bid=SymbolInfoDouble(symbol,SYMBOL_BID);             //   
    double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);             //   
    double price=bid-600*point;                                 //   
    price=NormalizeDouble(price,digits);                        //   
    int SL_pips=50;                                             // Stop Loss  
    int TP_pips=192;                                            // Take Profit  
    double SL=price+SL_pips*point;                              //   SL
    SL=NormalizeDouble(SL,digits);                              //  Stop Loss
    double TP=price-TP_pips*point;                              //   TP
    TP=NormalizeDouble(TP,digits);                              //  Take Profit
    datetime expiration=TimeTradeServer()+PeriodSeconds(PERIOD_D1);
    string comment=StringFormat("Sell Stop %s %G lots at %s, SL=%s TP=%s",
        symbol,volume,
        DoubleToString(price,digits),
        DoubleToString(SL,digits),
        DoubleToString(TP,digits));
    //---  ,      Buy Stop 
    if(!trade.SellStop(volume,price,symbol,SL,TP,ORDER_TIME_GTC,expiration,comment))
    {
        //---   
        Print(" SellStop()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
    }
    else
    {
        Print(" SellStop()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
    }
    //---     
}

////////////////////////////////////////////////////////////////////////////
void nachalo_raboty()
{
    if(!(flag))
    {
        TimeCurrent(my_data);

        {
            if (
                my_data.year == 2013 &&
                my_data.mon  ==    3 &&
                my_data.day  ==   15 &&
                my_data.hour ==   20 &&
                my_data.min  ==   00 &&
                my_data.sec  ==   00 
                )
            {
                datetime  time_start = TimeCurrent();
                Print("time_start = ",time_start);

                ObjectCreate(0," ",OBJ_VLINE,0,time_start,0);
                flag = true;
            }
        }
    }
}